Code

Merge branch 'js/stash'
[git.git] / git-stash.sh
index 18d3322ab5d57c8dc8e1333fc007861ef89e2d6d..eac5551380539e629c07e3f6afece9b5e2d16c0a 100755 (executable)
@@ -3,6 +3,7 @@
 
 USAGE='[ | list | show | apply | clear]'
 
+SUBDIRECTORY_OK=Yes
 . git-sh-setup
 require_work_tree
 
@@ -12,8 +13,8 @@ trap 'rm -f "$TMP-*"' 0
 ref_stash=refs/stash
 
 no_changes () {
-       git-diff-index --quiet --cached HEAD &&
-       git-diff-files --quiet
+       git diff-index --quiet --cached HEAD &&
+       git diff-files --quiet
 }
 
 clear_stash () {
@@ -23,6 +24,8 @@ clear_stash () {
 }
 
 save_stash () {
+       stash_msg="$1"
+
        if no_changes
        then
                echo >&2 'No local changes to save'
@@ -32,14 +35,14 @@ save_stash () {
                clear_stash || die "Cannot initialize stash"
 
        # state of the base commit
-       if b_commit=$(git-rev-parse --verify HEAD)
+       if b_commit=$(git rev-parse --verify HEAD)
        then
-               head=$(git-log --abbrev-commit --pretty=oneline -n 1 HEAD)
+               head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
        else
                die "You do not have the initial commit yet"
        fi
 
-       if branch=$(git-symbolic-ref -q HEAD)
+       if branch=$(git symbolic-ref -q HEAD)
        then
                branch=${branch#refs/heads/}
        else
@@ -48,9 +51,9 @@ save_stash () {
        msg=$(printf '%s: %s' "$branch" "$head")
 
        # state of the index
-       i_tree=$(git-write-tree) &&
+       i_tree=$(git write-tree) &&
        i_commit=$(printf 'index on %s' "$msg" |
-               git-commit-tree $i_tree -p $b_commit) ||
+               git commit-tree $i_tree -p $b_commit) ||
                die "Cannot save the current index state"
 
        # state of the working tree
@@ -59,59 +62,81 @@ save_stash () {
                export GIT_INDEX_FILE &&
 
                rm -f "$TMP-index" &&
-               git-read-tree $i_tree &&
-               git-add -u &&
-               git-write-tree &&
+               git read-tree $i_tree &&
+               git add -u &&
+               git write-tree &&
                rm -f "$TMP-index"
        ) ) ||
                die "Cannot save the current worktree state"
 
        # create the stash
-       w_commit=$(printf 'WIP on %s' "$msg" |
-               git-commit-tree $w_tree -p $b_commit -p $i_commit) ||
+       if test -z "$stash_msg"
+       then
+               stash_msg=$(printf 'WIP on %s' "$msg")
+       else
+               stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
+       fi
+       w_commit=$(printf '%s\n' "$stash_msg" |
+               git commit-tree $w_tree -p $b_commit -p $i_commit) ||
                die "Cannot record working tree state"
 
-       git-update-ref -m "$msg" $ref_stash $w_commit ||
+       git update-ref -m "$stash_msg" $ref_stash $w_commit ||
                die "Cannot save the current status"
-       printf >&2 'Saved WIP on %s\n' "$msg"
+       printf >&2 'Saved "%s"\n' "$stash_msg"
 }
 
 have_stash () {
-       git-rev-parse --verify $ref_stash >/dev/null 2>&1
+       git rev-parse --verify $ref_stash >/dev/null 2>&1
 }
 
 list_stash () {
        have_stash || return 0
-       git-log --pretty=oneline -g "$@" $ref_stash |
+       git log --pretty=oneline -g "$@" $ref_stash |
        sed -n -e 's/^[.0-9a-f]* refs\///p'
 }
 
 show_stash () {
-       flags=$(git-rev-parse --no-revs --flags "$@")
+       flags=$(git rev-parse --no-revs --flags "$@")
        if test -z "$flags"
        then
                flags=--stat
        fi
-       s=$(git-rev-parse --revs-only --no-flags --default $ref_stash "$@")
+       s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
 
-       w_commit=$(git-rev-parse --verify "$s") &&
-       b_commit=$(git-rev-parse --verify "$s^") &&
-       git-diff $flags $b_commit $w_commit
+       w_commit=$(git rev-parse --verify "$s") &&
+       b_commit=$(git rev-parse --verify "$s^") &&
+       git diff $flags $b_commit $w_commit
 }
 
 apply_stash () {
-       git-diff-files --quiet ||
+       git diff-files --quiet ||
                die 'Cannot restore on top of a dirty state'
 
+       unstash_index=
+       case "$1" in
+       --index)
+               unstash_index=t
+               shift
+       esac
+
        # current index state
-       c_tree=$(git-write-tree) ||
+       c_tree=$(git write-tree) ||
                die 'Cannot apply a stash in the middle of a merge'
 
-       s=$(git-rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
-       w_tree=$(git-rev-parse --verify "$s:") &&
-       b_tree=$(git-rev-parse --verify "$s^:") ||
+       s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
+       w_tree=$(git rev-parse --verify "$s:") &&
+       b_tree=$(git rev-parse --verify "$s^:") ||
                die "$*: no valid stashed state found"
 
+       test -z "$unstash_index" || {
+               git diff --binary $s^2^..$s^2 | git apply --cached
+               test $? -ne 0 &&
+                       die 'Conflicts in index. Try without --index.'
+               unstashed_index_tree=$(git-write-tree) ||
+                       die 'Could not save index tree'
+               git reset
+       }
+
        eval "
                GITHEAD_$w_tree='Stashed changes' &&
                GITHEAD_$c_tree='Updated upstream' &&
@@ -123,22 +148,25 @@ apply_stash () {
        then
                # No conflict
                a="$TMP-added" &&
-               git-diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
-               git-read-tree --reset $c_tree &&
-               git-update-index --add --stdin <"$a" ||
+               git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
+               git read-tree --reset $c_tree &&
+               git update-index --add --stdin <"$a" ||
                        die "Cannot unstage modified files"
                git-status
                rm -f "$a"
+               test -z "$unstash_index" || git read-tree $unstashed_index_tree
        else
                # Merge conflict; keep the exit status from merge-recursive
-               exit
+               status=$?
+               test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
+               exit $status
        fi
 }
 
 # Main command set
 case "$1" in
-list | '')
-       test $# -gt 0 && shift
+list)
+       shift
        if test $# = 0
        then
                set x -n 10
@@ -157,9 +185,14 @@ apply)
 clear)
        clear_stash
        ;;
-save)
-       save_stash && git-reset --hard
+help | usage)
+       usage
        ;;
 *)
-       usage
+       if test $# -gt 0 && test "$1" = save
+       then
+               shift
+       fi
+       save_stash "$*" && git-reset --hard
+       ;;
 esac